<script lang="ts">
  import StoneC from "./Stone.svelte";
  import { getDestinationSquares, squareEquals, stoneColor } from "../utils";

  import { createEventDispatcher } from "svelte";
  const dispatch = createEventDispatcher();

  export let dark: boolean = false;
  export let stones: Board;
  export let activeSquare: Square | null;
  export let disabled: boolean = false;
  export let passiveMove: Move | null;
  export let flipped: boolean;
  export let playerColor: PlayerColor | null;

  let destinationSquares: Square[] | null;
  $: {
    destinationSquares =
      activeSquare && getDestinationSquares(stones, activeSquare);
  }

  const squares: Square[] = [0, 1, 2, 3].flatMap((y) =>
    [0, 1, 2, 3].map((x) => [x, y] as Square)
  );

  let sortedStones: [Square, Stone][];
  $: {
    sortedStones = [...stones];
    sortedStones.sort(([_squareA, stoneA], [_squareB, stoneB]) => {
      if (stoneA > stoneB) {
        return 1;
      } else if (stoneA < stoneB) {
        return -1;
      } else {
        return 0;
      }
    });
  }

  function gridElementStyle(square: Square) {
    const [x, y] = square;

    return `grid-row-start: ${y + 1}; grid-row-end: ${
      y + 2
    }; grid-column-start: ${x + 1}; grid-column-end: ${x + 2}`;
  }

  function stoneStyle(square: Square) {
    const [x, y] = square;

    let outOfBounds = x < 0 || x > 3 || y < 0 || y > 3;

    return `left: ${25 * x}%; top: ${25 * y}%; ${
      outOfBounds ? "visibility: hidden; opacity: 0;" : ""
    }`;
  }

  function isSquareEnabled(
    activeSquare: Square | null,
    destinationSquares: Square[] | null,
    square: Square
  ): boolean {
    return (
      activeSquare !== null &&
      destinationSquares !== null &&
      destinationSquares.some((s) => squareEquals(s, square))
    );
  }

  function handleSquareClick(square: Square) {
    dispatch("click:square", square);
  }

  function isStoneEnabled(
    playerColor: PlayerColor | null,
    stone: Stone
  ): boolean {
    return stoneColor(stone) === playerColor;
  }

  function handleStoneClick(square: Square) {
    dispatch("click:stone", square);
  }
</script>

<div class="board" class:flipped class:dark class:active={activeSquare}>
  <div class="inner">
    {#each squares as square}
      <button
        disabled={disabled ||
          !isSquareEnabled(activeSquare, destinationSquares, square)}
        class="square"
        class:active={(activeSquare !== null &&
          squareEquals(square, activeSquare)) ||
          (passiveMove &&
            (squareEquals(passiveMove.from, square) ||
              squareEquals(passiveMove.to, square)))}
        class:hinted={destinationSquares &&
          destinationSquares.some((d) => squareEquals(d, square))}
        on:click={() => handleSquareClick(square)}
        style={gridElementStyle(square)}
      >
        <div class="square-inner" />
      </button>
    {/each}

    {#each sortedStones as [square, stone] (stone)}
      <button
        disabled={disabled || !isStoneEnabled(playerColor, stone)}
        class="stone"
        on:click={() => handleStoneClick(square)}
        style={stoneStyle(square)}
      >
        <div class="stone-inner">
          <StoneC color={stoneColor(stone)} />
        </div>
      </button>
    {/each}
  </div>
</div>

<style>
  .board {
    position: relative;
    filter: drop-shadow(3px 3px 5px #0007);
  }
  .flipped.board {
    filter: drop-shadow(-3px -3px 5px #0007);
  }

  .inner {
    box-sizing: border-box;
    position: relative;

    display: grid;
    grid-template-columns: 1fr 1fr 1fr 1fr;
    grid-template-rows: 1fr 1fr 1fr 1fr;

    background-color: #dbb574;
    border-radius: 1%;
  }

  .dark .inner {
    background-color: rgb(171, 126, 72);
  }

  .square {
    background-color: #f3daab;
    margin: 3%;
    border-radius: 3%;
    position: relative;
  }
  .square-inner {
    padding-bottom: 100%;
  }

  .square-inner::after {
    transition: top 0.2s, left 0.2s, right 0.2s, bottom 0.2s;

    background-color: rgba(79, 194, 69, 0.5);
  }
  .dark .square-inner::after {
    background-color: rgba(38, 163, 27, 0.5);
  }

  .square.active > .square-inner::after {
    content: "";
    position: absolute;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
  }

  .square.hinted > .square-inner::after {
    content: "";
    position: absolute;
    border-radius: 100%;
    top: 30%;
    left: 30%;
    right: 30%;
    bottom: 30%;
  }

  .stone-inner {
    width: 90%;
    padding: 12.5%;
  }
  .stone {
    position: absolute;

    width: 25%;
    height: 25%;

    transition: top 0.25s, left 0.25s, visibility 0.25s, opacity 0.25s;

    display: flex;
    justify-content: center;
    align-items: center;
  }
  .flipped .stone {
    transform: rotate(180deg);
  }
  button {
    text-align: inherit;
    line-height: inherit;
    font-size: inherit;
    background-color: transparent;

    border: 0;
    padding: 0;
    cursor: pointer;
  }
  button:disabled {
    cursor: inherit;
  }

  .dark .square {
    background-color: rgb(212, 165, 110);
  }
</style>
